﻿// Webcam Signature 1.1
// Created by Eric Wong
// Copyright 2008
// This is open source software licensed under the GNU GENERAL PUBLIC LICENSE V3.
// You must share your source code if you utilize this code in your program.
// I wish to promote the development of computer vision so that it is easy to use
// for casual users and programmers, as well as advanced ones. Right now, many of the
// techniques used in computer vision are quite archaic and without easy to understand
// coding. Please share.
// Comments for this section to come.

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
//using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using SampleGrabberNET;


namespace WebCam_Signature
{
    public partial class FineTuneTrackColorsForm : Form
    {
        [DllImport("user32.dll")]
        static extern IntPtr GetForegroundWindow();

        MainForm parentForm;
        Bitmap SampleStaticBack;
        Bitmap SelectColor;
        PixelData PixelFromPoint;

        public FineTuneTrackColorsForm(MainForm qparent)
        {
            parentForm = qparent;
            GC.KeepAlive(parentForm);
            InitializeComponent();

            this.Show();
            this.BringToFront();
        }

        private void FineTuneTrackColorsForm_FormClosing(object sender, FormClosingEventArgs e)
        {
            parentForm.FineTuneTC = null;
        }

        private void FineTuneTrackColorsForm_Shown(object sender, EventArgs e)
        {
            LoadSettings();
            groupBox1.Focus();
        }

        public void LoadSettings()
        {
            ColorRangeThresNB.Value = (decimal)UserSettings.Default.TrackColorRangeThres;
            if (UserSettings.Default.TrackRed)
            {
                FineTuningColor.Text = "RED RGB Settings";

                TBRedLow.Value = UserSettings.Default.TRLowRed;
                TBRedHigh.Value = UserSettings.Default.TRHighRed;
                TBGreenLow.Value = UserSettings.Default.TRLowGreen;
                TBGreenHigh.Value = UserSettings.Default.TRHighGreen;
                TBBlueLow.Value = UserSettings.Default.TRLowBlue;
                TBBlueHigh.Value = UserSettings.Default.TRHighBlue;
            }
            else if (UserSettings.Default.TrackGreen)
            {
                FineTuningColor.Text = "GREEN RGB Settings";

                TBRedLow.Value = UserSettings.Default.TGLowRed;
                TBRedHigh.Value = UserSettings.Default.TGHighRed;
                TBGreenLow.Value = UserSettings.Default.TGLowGreen;
                TBGreenHigh.Value = UserSettings.Default.TGHighGreen;
                TBBlueLow.Value = UserSettings.Default.TGLowBlue;
                TBBlueHigh.Value = UserSettings.Default.TGHighBlue;
            }
            else
            {
                FineTuningColor.Text = "BLUE RGB Settings";

                TBRedLow.Value = UserSettings.Default.TBLowRed;
                TBRedHigh.Value = UserSettings.Default.TBHighRed;
                TBGreenLow.Value = UserSettings.Default.TBLowGreen;
                TBGreenHigh.Value = UserSettings.Default.TBHighGreen;
                TBBlueLow.Value = UserSettings.Default.TBLowBlue;
                TBBlueHigh.Value = UserSettings.Default.TBHighBlue;
            }

            SelectColor = parentForm.GetFullFrameBitmap();
            SelectColorPB.Image = SelectColor;

            // For Filter Background
            if (UserSettings.Default.NoBackgroundFilter == true)
                NoBackFilterRB.Checked = true;
            else
                NoBackFilterRB.Checked = false;

            if (UserSettings.Default.UseStaticBackFilter == true)
                UseBackStaticFilterRB.Checked = true;
            else
                UseBackStaticFilterRB.Checked = false;

            if (UserSettings.Default.UseDynamicBackFilter == true)
                UseBackDynamicFilterRB.Checked = true;
            else
                UseBackDynamicFilterRB.Checked = false;

            BackRefreshTimeNB.Value = (decimal)UserSettings.Default.BackgroundRefreshTime;
            BackCalibrationTimeNB.Value = (decimal)UserSettings.Default.BackgroundCalibrateTime;
            BackDiffThreshNB.Value = (decimal)UserSettings.Default.BackgroundDiffThreshold;
            timer1.Enabled = false;
            RefreshBackFilterProgress.Value = 100;
            CaptureBackgroundButton_MouseClick(this, null);
            BackFilteringInfo.Clear();
            BackFilteringInfo.Text = "* Static filtering takes a still picture of your background and utilizes that to filter out the background. It is more effective than dynamic filtering if you are sure that your webcam won't be moved. \r\n"
                +"* Dynamic filtering is recommended because it will update the background over a period of time (Refresh Time) so that new objects or movements of the webcam are taken into account.";
            RGBSettingsInfo.Text = "* This section allows you to adjust the range of colors that the program tracks. To change the range of colors, either adjust the sliders at the left to" +
                " manually change the RGB values or click \"Grab A Frame\" and and click on the color you want from the image. \r\n" +
                "* Even with selecting a color from the picture, you may still have to fine tune the track bars above to get a stable tracking. \r\n"+
                "* The program comes with default settings for Red, Blue, and Green colors for BIC pens. \r\n" + 
                "* Note that you can change the \"Red\", \"Green\", and \"Blue\" tracking colors to what ever you want them to be. "+
                "You do not have to keep them restricted to the color of their names. Try using a flashlight and set them to white!";
        }

        private void TBRedLow_Scroll(object sender, EventArgs e)
        {
            if (UserSettings.Default.TrackRed)
            {
                UserSettings.Default.TRLowRed = TBRedLow.Value;
                //UserSettings.Default.TRHighRed = TBRedHigh.Value;
                //UserSettings.Default.TRLowGreen = TBGreenLow.Value ;
                //UserSettings.Default.TRHighGreen = TBGreenHigh.Value;
                //UserSettings.Default.TRLowBlue = TBBlueLow.Value;
                //UserSettings.Default.TRHighBlue = TBGreenHigh.Value;
            }
            else if (UserSettings.Default.TrackGreen)
            {
                UserSettings.Default.TGLowRed = TBRedLow.Value;
                //UserSettings.Default.TGHighRed = TBRedHigh.Value;
                //UserSettings.Default.TGLowGreen = TBGreenLow.Value;
                //UserSettings.Default.TGHighGreen = TBGreenHigh.Value;
                //UserSettings.Default.TGLowBlue = TBBlueLow.Value;
                //UserSettings.Default.TGHighBlue = TBGreenHigh.Value;
            }
            else
            {
                UserSettings.Default.TBLowRed = TBRedLow.Value;
                //UserSettings.Default.TBHighRed = TBRedHigh.Value;
                //UserSettings.Default.TBLowGreen = TBGreenLow.Value;
                //UserSettings.Default.TBHighGreen = TBGreenHigh.Value;
                //UserSettings.Default.TBLowBlue = TBBlueLow.Value;
                //UserSettings.Default.TBHighBlue = TBGreenHigh.Value;
            }

            UserSettings.Default.Save();
            parentForm.UpdateTrackColorSample();
            parentForm.LoadTrackColor();
        }

        private void TBRedHigh_Scroll(object sender, EventArgs e)
        {
            if (UserSettings.Default.TrackRed)
            {
                UserSettings.Default.TRHighRed = TBRedHigh.Value;
            }
            else if (UserSettings.Default.TrackGreen)
            {
                UserSettings.Default.TGHighRed = TBRedHigh.Value;
            }
            else
            {
                UserSettings.Default.TBHighRed = TBRedHigh.Value;
            }

            UserSettings.Default.Save();
            parentForm.UpdateTrackColorSample();
            parentForm.LoadTrackColor();
        }

        private void TBGreenLow_Scroll(object sender, EventArgs e)
        {
            if (UserSettings.Default.TrackRed)
            {
                UserSettings.Default.TRLowGreen = TBGreenLow.Value;
            }
            else if (UserSettings.Default.TrackGreen)
            {
                UserSettings.Default.TGLowGreen = TBGreenLow.Value;
            }
            else
            {
                UserSettings.Default.TBLowGreen = TBGreenLow.Value;
            }

            UserSettings.Default.Save();
            parentForm.UpdateTrackColorSample();
            parentForm.LoadTrackColor();
        }

        private void TBGreenHigh_Scroll(object sender, EventArgs e)
        {
            if (UserSettings.Default.TrackRed)
            {
                UserSettings.Default.TRHighGreen = TBGreenHigh.Value;
            }
            else if (UserSettings.Default.TrackGreen)
            {
                UserSettings.Default.TGHighGreen = TBGreenHigh.Value;
            }
            else
            {
                UserSettings.Default.TBHighGreen = TBGreenHigh.Value;
            }

            UserSettings.Default.Save();
            parentForm.UpdateTrackColorSample();
            parentForm.LoadTrackColor();
        }

        private void TBBlueLow_Scroll(object sender, EventArgs e)
        {
            if (UserSettings.Default.TrackRed)
            {
                UserSettings.Default.TRLowBlue = TBBlueLow.Value;
            }
            else if (UserSettings.Default.TrackGreen)
            {
                UserSettings.Default.TGLowBlue = TBBlueLow.Value;
            }
            else
            {
                UserSettings.Default.TBLowBlue = TBBlueLow.Value;
            }

            UserSettings.Default.Save();
            parentForm.UpdateTrackColorSample();
            parentForm.LoadTrackColor();
        }

        private void TBBlueHigh_Scroll(object sender, EventArgs e)
        {
            if (UserSettings.Default.TrackRed)
            {
                UserSettings.Default.TRHighBlue = TBBlueHigh.Value;
            }
            else if (UserSettings.Default.TrackGreen)
            {
                UserSettings.Default.TGHighBlue = TBBlueHigh.Value;
            }
            else
            {
                UserSettings.Default.TBHighBlue = TBBlueHigh.Value;
            }

            UserSettings.Default.Save();
            parentForm.UpdateTrackColorSample();
            parentForm.LoadTrackColor();
        }

        private void ResetFineTune_MouseClick(object sender, MouseEventArgs e)
        {
            if (UserSettings.Default.TrackRed)
            {
                FineTuningColor.Text = "RED RGB Settings";

                UserSettings.Default.TRLowRed = 140;
                UserSettings.Default.TRHighRed = 255;
                UserSettings.Default.TRLowGreen = 0;
                UserSettings.Default.TRHighGreen = 70;
                UserSettings.Default.TRLowBlue = 0;
                UserSettings.Default.TRHighBlue = 70;
            }
            else if (UserSettings.Default.TrackGreen)
            {
                FineTuningColor.Text = "GREEN RGB Settings";

                UserSettings.Default.TGLowRed = 0;
                UserSettings.Default.TGHighRed = 70;
                UserSettings.Default.TGLowGreen = 140;
                UserSettings.Default.TGHighGreen = 255;
                UserSettings.Default.TGLowBlue = 0;
                UserSettings.Default.TGHighBlue = 70;
            }
            else
            {
                FineTuningColor.Text = "BLUE RGB Settings";

                UserSettings.Default.TBLowRed = 0;
                UserSettings.Default.TBHighRed = 70;
                UserSettings.Default.TBLowGreen = 0;
                UserSettings.Default.TBHighGreen = 70;
                UserSettings.Default.TBLowBlue = 140;
                UserSettings.Default.TBHighBlue = 255;
            }

            UserSettings.Default.Save();
            parentForm.UpdateTrackColorSample();
            parentForm.LoadTrackColor();
            LoadSettings();
        }

        private void FineTuneTrackColorsForm_Deactivate(object sender, EventArgs e)
        {
            if (GetForegroundWindow() != parentForm.Handle)
            {
                parentForm.MainForm_Deactivate(this, null);
            }
        }

        private void FineTuneTrackColorsForm_Activated(object sender, EventArgs e)
        {
            parentForm.MainForm_Activated(this, null);
        }


        private void ResetBackFilterButton_MouseClick(object sender, MouseEventArgs e)
        {
            UserSettings.Default.NoBackgroundFilter = false;
            UserSettings.Default.UseStaticBackFilter = false;
            UserSettings.Default.UseDynamicBackFilter = true;
            UserSettings.Default.BackgroundRefreshTime = 60;
            UserSettings.Default.BackgroundCalibrateTime = 2;
            UserSettings.Default.BackgroundDiffThreshold = 50;

            UserSettings.Default.Save();
            LoadSettings();
            UpdateBackFilter();
        }

        private void BackCalibrationTimeNB_ValueChanged(object sender, EventArgs e)
        {
            UserSettings.Default.BackgroundRefreshTime = (int)BackCalibrationTimeNB.Value;
            UserSettings.Default.Save();
            UpdateBackFilter();
        }

        private void BackDiffThreshNB_ValueChanged(object sender, EventArgs e)
        {
            UserSettings.Default.BackgroundDiffThreshold = (int)BackDiffThreshNB.Value;
            UserSettings.Default.Save();
            UpdateBackFilter();
        }

        private void BackRefreshTimeNB_ValueChanged(object sender, EventArgs e)
        {
            UserSettings.Default.BackgroundRefreshTime = (int)BackRefreshTimeNB.Value;
            UserSettings.Default.Save();
            UpdateBackFilter();
        }

        private void NoBackFilterRB_MouseClick(object sender, MouseEventArgs e)
        {
            if (NoBackFilterRB.Checked == true)
            {
                UserSettings.Default.NoBackgroundFilter = true;
                UserSettings.Default.UseStaticBackFilter = false;
                UserSettings.Default.UseDynamicBackFilter = false;
                UseBackStaticFilterRB.Checked = false;
                UseBackDynamicFilterRB.Checked = false;
            }
            else if (NoBackFilterRB.Checked == false && UseBackStaticFilterRB.Checked == false && UseBackDynamicFilterRB.Checked == false)
            {
                UserSettings.Default.NoBackgroundFilter = true;
                UserSettings.Default.UseStaticBackFilter = false;
                UserSettings.Default.UseDynamicBackFilter = false;
                NoBackFilterRB.Checked = true;
                UseBackStaticFilterRB.Checked = false;
                UseBackDynamicFilterRB.Checked = false;
            }
            UserSettings.Default.Save();

            UpdateBackFilter();
        }

        private void UseBackStaticFilterRB_MouseClick(object sender, MouseEventArgs e)
        {
            if (UseBackStaticFilterRB.Checked == true)
            {
                UserSettings.Default.NoBackgroundFilter = false;
                UserSettings.Default.UseStaticBackFilter = true;
                UserSettings.Default.UseDynamicBackFilter = false;
                NoBackFilterRB.Checked = false;
                UseBackDynamicFilterRB.Checked = false;
            }
            else if (NoBackFilterRB.Checked == false && UseBackStaticFilterRB.Checked == false && UseBackDynamicFilterRB.Checked == false)
            {
                UserSettings.Default.NoBackgroundFilter = true;
                UserSettings.Default.UseStaticBackFilter = false;
                UserSettings.Default.UseDynamicBackFilter = false;
                NoBackFilterRB.Checked = true;
                UseBackStaticFilterRB.Checked = false;
                UseBackDynamicFilterRB.Checked = false;
            }
            UserSettings.Default.Save();
            UpdateBackFilter();
        }

        private void UseBackDynamicFilterRB_MouseClick(object sender, MouseEventArgs e)
        {
            if (UseBackDynamicFilterRB.Checked == true)
            {
                UserSettings.Default.NoBackgroundFilter = false;
                UserSettings.Default.UseStaticBackFilter = false;
                UserSettings.Default.UseDynamicBackFilter = true;
                NoBackFilterRB.Checked = false;
                UseBackStaticFilterRB.Checked = false;
            }
            else if (NoBackFilterRB.Checked == false && UseBackStaticFilterRB.Checked == false && UseBackDynamicFilterRB.Checked == false)
            {
                UserSettings.Default.NoBackgroundFilter = true;
                UserSettings.Default.UseStaticBackFilter = false;
                UserSettings.Default.UseDynamicBackFilter = false;
                NoBackFilterRB.Checked = true;
                UseBackStaticFilterRB.Checked = false;
                UseBackDynamicFilterRB.Checked = false;
            }
            UserSettings.Default.Save();
            UpdateBackFilter();
        }

        private void RefreshBackFilterButton_MouseClick(object sender, MouseEventArgs e)
        {
            UpdateBackFilter();
        }


        private void CaptureBackgroundButton_MouseClick(object sender, MouseEventArgs e)
        {
            SampleStaticBack = new Bitmap(parentForm.GetStaticBackBitmap());
            StaticBackFilterPB.Image = SampleStaticBack;
        }

        private void UpdateBackFilter()
        {
            parentForm.RefreshBackFilteringParams();
            timer1.Enabled = true;
            timer1.Start();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            RefreshBackFilterProgress.Value = parentForm.RefreshingBackgroundFilterProgress();
            if (RefreshBackFilterProgress.Value >= 100)
            {
                timer1.Stop();
                timer1.Enabled = false;
                CaptureBackgroundButton_MouseClick(this, null);
            }
        }

        private void GrabAFrameButton_MouseClick(object sender, MouseEventArgs e)
        {
            try
            {
                SelectColor = new Bitmap(parentForm.GetFullFrameBitmap());
                SelectColorPB.Image = SelectColor;
            }
            catch (Exception ee)
            {
                Console.WriteLine("Error. No webcam picture available");
            }
            GC.KeepAlive(parentForm);
        }


        private void SelectColorPB_MouseClick(object sender, MouseEventArgs e)
        {
            Point PointofColor = e.Location;

            Bitmap tempBitmap = new Bitmap(SelectColor);
            UnsafeBitmap WebCamBitmap = new UnsafeBitmap(ref tempBitmap, true);
            WebCamBitmap.LockBitmap();
            PixelFromPoint = new PixelData();
            PixelFromPoint = WebCamBitmap.GetPixel(PointofColor.X, PointofColor.Y);
            PixelData tempPixel;

            PixelData transparentPixel = new PixelData();
            transparentPixel.red = (byte)0;
            transparentPixel.green = (byte)0;
            transparentPixel.blue = (byte)0;

            int TCRange = UserSettings.Default.TrackColorRangeThres;

            for (int i = 0; i < WebCamBitmap.Bitmap.Width; i++)
            {
                for (int j = 0; j < WebCamBitmap.Bitmap.Height; j++)
                {
                    tempPixel = WebCamBitmap.GetPixel(i, j);
                    if (Math.Abs((int)tempPixel.blue - (int)PixelFromPoint.blue) > TCRange
                        || Math.Abs((int)tempPixel.red - (int)PixelFromPoint.red) > TCRange
                        || Math.Abs((int)tempPixel.green - (int)PixelFromPoint.green) > TCRange)
                    {
                        WebCamBitmap.SetPixel(i, j, transparentPixel);
                    }
                }
            }
            WebCamBitmap.UnlockBitmap();
            SelectColor = new Bitmap(tempBitmap);
            SelectColorPB.Image = SelectColor;

            SetTCwithTCRange();
        }

        private void ColorRangeThresNB_ValueChanged(object sender, EventArgs e)
        {
            UserSettings.Default.TrackColorRangeThres = (int)ColorRangeThresNB.Value;
            UserSettings.Default.Save();

            //SetTCwithTCRange();
        }

        private void SetTCwithTCRange()
        {
            int TCRange = UserSettings.Default.TrackColorRangeThres;
            if (UserSettings.Default.TrackRed)
            {
                FineTuningColor.Text = "RED RGB Settings";

                UserSettings.Default.TRLowRed = (int)PixelFromPoint.red - TCRange;
                if (UserSettings.Default.TRLowRed < 0)
                    UserSettings.Default.TRLowRed = 0;

                UserSettings.Default.TRHighRed = (int)PixelFromPoint.red + TCRange;
                if (UserSettings.Default.TRHighRed > 255)
                    UserSettings.Default.TRHighRed = 255;

                UserSettings.Default.TRLowGreen = (int)PixelFromPoint.green - TCRange;
                if (UserSettings.Default.TRLowGreen < 0)
                    UserSettings.Default.TRLowGreen = 0;

                UserSettings.Default.TRHighGreen = (int)PixelFromPoint.green + TCRange;
                if (UserSettings.Default.TRHighGreen > 255)
                    UserSettings.Default.TRHighGreen = 255;

                UserSettings.Default.TRLowBlue = (int)PixelFromPoint.blue - TCRange;
                if (UserSettings.Default.TRLowBlue < 0)
                    UserSettings.Default.TRLowBlue = 0;

                UserSettings.Default.TRHighBlue = (int)PixelFromPoint.blue + TCRange;
                if (UserSettings.Default.TRHighBlue > 255)
                    UserSettings.Default.TRHighBlue = 255;
            }
            else if (UserSettings.Default.TrackGreen)
            {
                FineTuningColor.Text = "GREEN RGB Settings";

                UserSettings.Default.TGLowRed = (int)PixelFromPoint.red - TCRange;
                if (UserSettings.Default.TGLowRed < 0)
                    UserSettings.Default.TGLowRed = 0;

                UserSettings.Default.TGHighRed = (int)PixelFromPoint.red + TCRange;
                if (UserSettings.Default.TGHighRed > 255)
                    UserSettings.Default.TGHighRed = 255;

                UserSettings.Default.TGLowGreen = (int)PixelFromPoint.green - TCRange;
                if (UserSettings.Default.TGLowGreen < 0)
                    UserSettings.Default.TGLowGreen = 0;

                UserSettings.Default.TGHighGreen = (int)PixelFromPoint.green + TCRange;
                if (UserSettings.Default.TGHighGreen > 255)
                    UserSettings.Default.TGHighGreen = 255;

                UserSettings.Default.TGLowBlue = (int)PixelFromPoint.blue - TCRange;
                if (UserSettings.Default.TGLowBlue < 0)
                    UserSettings.Default.TGLowBlue = 0;

                UserSettings.Default.TGHighBlue = (int)PixelFromPoint.blue + TCRange;
                if (UserSettings.Default.TGHighBlue > 255)
                    UserSettings.Default.TGHighBlue = 255;
            }
            else
            {
                FineTuningColor.Text = "BLUE RGB Settings";

                UserSettings.Default.TBLowRed = (int)PixelFromPoint.red - TCRange;
                if (UserSettings.Default.TBLowRed < 0)
                    UserSettings.Default.TBLowRed = 0;

                UserSettings.Default.TBHighRed = (int)PixelFromPoint.red + TCRange;
                if (UserSettings.Default.TBHighRed > 255)
                    UserSettings.Default.TBHighRed = 255;

                UserSettings.Default.TBLowGreen = (int)PixelFromPoint.green - TCRange;
                if (UserSettings.Default.TBLowGreen < 0)
                    UserSettings.Default.TBLowGreen = 0;

                UserSettings.Default.TBHighGreen = (int)PixelFromPoint.green + TCRange;
                if (UserSettings.Default.TBHighGreen > 255)
                    UserSettings.Default.TBHighGreen = 255;

                UserSettings.Default.TBLowBlue = (int)PixelFromPoint.blue - TCRange;
                if (UserSettings.Default.TBLowBlue < 0)
                    UserSettings.Default.TBLowBlue = 0;

                UserSettings.Default.TBHighBlue = (int)PixelFromPoint.blue + TCRange;
                if (UserSettings.Default.TBHighBlue > 255)
                    UserSettings.Default.TBHighBlue = 255;
            }

            UserSettings.Default.Save();

            parentForm.UpdateTrackColorSample();
            parentForm.LoadTrackColor();


            if (UserSettings.Default.TrackRed)
            {
                FineTuningColor.Text = "RED RGB Settings";

                TBRedLow.Value = UserSettings.Default.TRLowRed;
                TBRedHigh.Value = UserSettings.Default.TRHighRed;
                TBGreenLow.Value = UserSettings.Default.TRLowGreen;
                TBGreenHigh.Value = UserSettings.Default.TRHighGreen;
                TBBlueLow.Value = UserSettings.Default.TRLowBlue;
                TBBlueHigh.Value = UserSettings.Default.TRHighBlue;
            }
            else if (UserSettings.Default.TrackGreen)
            {
                FineTuningColor.Text = "GREEN RGB Settings";

                TBRedLow.Value = UserSettings.Default.TGLowRed;
                TBRedHigh.Value = UserSettings.Default.TGHighRed;
                TBGreenLow.Value = UserSettings.Default.TGLowGreen;
                TBGreenHigh.Value = UserSettings.Default.TGHighGreen;
                TBBlueLow.Value = UserSettings.Default.TGLowBlue;
                TBBlueHigh.Value = UserSettings.Default.TGHighBlue;
            }
            else
            {
                FineTuningColor.Text = "BLUE RGB Settings";

                TBRedLow.Value = UserSettings.Default.TBLowRed;
                TBRedHigh.Value = UserSettings.Default.TBHighRed;
                TBGreenLow.Value = UserSettings.Default.TBLowGreen;
                TBGreenHigh.Value = UserSettings.Default.TBHighGreen;
                TBBlueLow.Value = UserSettings.Default.TBLowBlue;
                TBBlueHigh.Value = UserSettings.Default.TBHighBlue;
            }
        }

    }
}
